#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import <UIKit/UIView.h>
#ifndef ASPEN
#import "WebCore/WebFontCache.h"
#endif
#import <GraphicsServices/GraphicsServices.h>

#ifdef ASPEN
// include for the sdk compiler and open toolchain headers
#ifndef UIKIT_UIFont_UIColor_H
#define UIKIT_UIFont_UIColor_H
typedef float CGFloat;
#import <UIKit/UIFont.h>
#import <UIKit/UIColor.h>
#endif //UIKIT_UIFont_UIColor_H

#ifndef UIKIT_UITouch_UIEvent_H
#define UIKIT_UITouch_UIEvent_H
typedef unsigned int NSUInteger;
#import <UIKit/UITouch.h>
#import <UIKit/UIEvent.h>
#endif //UIKIT_UITouch_UIEvent_H

#endif //ASPEN

@class TrisApp;

@interface TrisAboutView : UIView
{
	TrisApp *app;
	UIImageView *icon;
	UIImageView *logo;
#ifdef ASPEN
	UIFont *lFont;
#else
	struct __GSFont *lFont;
#endif
	CGColorRef whc;
	CGColorRef tpc;
	NSArray *labels;
	UITextLabel *version;
	UITextLabel *contact;
	UITextLabel *thanks;
}

- (id)initWithApp:(TrisApp *)a;
- (UITextLabel *)addLabelInFrame:(CGRect)frm text:(NSString *)txt;

@end
