#import "TrisAboutView.h"


@interface TrisApp : UIApplication {}
	- (void)unhideMenu;
@end

@implementation TrisAboutView

- (id)initWithApp:(TrisApp *)a
{
	if(self = [super initWithFrame:CGRectMake(0.f,0.f,320.f,460.f)])
	{
		[self setAlpha:0.0];
		app = a;
		icon = [[UIImageView alloc] initWithFrame:CGRectMake(86.f,52.f,59.f,60.f)];
		[icon setImage:[UIImage applicationImageNamed:@"icon.png"]];
		[self addSubview:icon];
		logo = [[UIImageView alloc] initWithFrame:CGRectMake(63.f,122.f,102.f,45.f)];
		[logo setImage:[UIImage applicationImageNamed:@"logo-glow.png"]];
		[self addSubview:logo];
		
		CGColorSpaceRef csp = CGColorSpaceCreateDeviceRGB();
		float whf[4] = {1.0,1.0,1.0,1.0};
		float sdf[4] = {0.0,0.0,0.0,0.7};
		float tpf[4] = {0.0,0.0,0.0,0.0};
		
		float blf[4] = {0.0,0.0,0.0,0.4};
		[[self _layer] setBackgroundColor:CGColorCreate(csp,blf)];
		
		whc = CGColorCreate(csp,whf); // white text
		
		tpc = CGColorCreate(csp,tpf); // transparency (for background)
		
#ifdef ASPEN
		UIFont *vFont = [UIFont fontWithName:@"Helvetica" size:17];
#else
		struct __GSFont *vFont = [NSClassFromString(@"WebFontCache") createFontWithFamily:@"Helvetica" traits:2 size:17];
#endif
		CGColorRef sdc = CGColorCreate(csp,sdf); // shadow color
		
		version = [[[UITextLabel alloc] initWithFrame:CGRectMake(64,182,102,24)] retain];
		[version setFont:vFont];
#ifdef ASPEN
		[version setColor:[UIColor colorWithCGColor:whc]];
#else
		[version setColor:whc];
#endif
		[version setCentersHorizontally:YES];
		[version setText:@"Version 0.6"];
#ifdef ASPEN
		[version setBackgroundColor:[UIColor colorWithCGColor:tpc]];
		[version setShadowColor:[UIColor colorWithCGColor:sdc]];
#else
		[version setBackgroundColor:tpc];
		[version setShadowColor:sdc];
#endif
		[version setShadowOffset:CGSizeMake(0,2)];
		[self addSubview:version];
		
#ifdef ASPEN
		lFont = [UIFont fontWithName:@"Helvetica" size:15];
#else
		lFont = [NSClassFromString(@"WebFontCache") createFontWithFamily:@"Helvetica" traits:0 size:15];
#endif
		
		// can't get multiline text labels for some reason, so this instead
		
		NSMutableArray *lblArr = [NSMutableArray arrayWithCapacity:8];
		
		[lblArr addObject:[self addLabelInFrame:CGRectMake(30,200,170,20) text:@"by Noah Witherspoon"]];
		[lblArr addObject:[self addLabelInFrame:CGRectMake(30,218,170,20) text:@"mahalis@gmail.com"]];
		
#ifdef ASPEN
		UIFont *blFont = [UIFont fontWithName:@"Helvetica" size:15];
#else
		struct __GSFont *blFont = [NSClassFromString(@"WebFontCache") createFontWithFamily:@"Helvetica" traits:2 size:15];
#endif
		UITextLabel *tt = [self addLabelInFrame:CGRectMake(40,264,150,20) text:@"Thanks to:"];
		[tt setFont:blFont];
		[lblArr addObject:tt];
		
		[lblArr addObject:[self addLabelInFrame:CGRectMake(30,280,170,20) text:@"lduncan and JoeBrain"]];
		[lblArr addObject:[self addLabelInFrame:CGRectMake(30,296,170,20) text:@"of #iphone-uikit"]];
		[lblArr addObject:[self addLabelInFrame:CGRectMake(30,330,170,20) text:@"Zibri for his jailbreak"]];
		[lblArr addObject:[self addLabelInFrame:CGRectMake(20,360,190,20) text:@"and to the clever hackers"]];
		[lblArr addObject:[self addLabelInFrame:CGRectMake(20,376,190,20) text:@"who made it all possible"]];

#ifdef ASPEN
		[lblArr addObject:[self addLabelInFrame:CGRectMake(20,392,190,20) text:@"ported to 2.0 by javacom"]];
#endif
		
		// immutable copy
		labels = [[NSArray arrayWithArray:lblArr] retain];
	}
	return self;
}

- (UITextLabel *)addLabelInFrame:(CGRect)frm text:(NSString *)txt
{
	UITextLabel *t = [[[UITextLabel alloc] initWithFrame:frm] retain];
	[t setFont:lFont];
#ifdef ASPEN
	[t setColor:[UIColor colorWithCGColor:whc]];
	[t setBackgroundColor:[UIColor colorWithCGColor:tpc]];
#else
	[t setColor:whc];
	[t setBackgroundColor:tpc];
#endif
	[t setCentersHorizontally:YES];
	[t setText:txt];
	[self addSubview:t];
	return t;
}

#if defined ASPEN && !defined USE_LEGACY_EVENT

- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event
{  
	UIAlphaAnimation *va = [[UIAlphaAnimation alloc] initWithTarget:self];
	[va setStartAlpha:1.0];
	[va setEndAlpha:0.0];
	
	UIAnimator *ua = [[UIAnimator alloc] init];
	[ua addAnimation:va withDuration:0.4 start:YES];
	
	[app unhideMenu];
}
#else
- (void)mouseUp:(GSEvent *)evt
{	
	UIAlphaAnimation *va = [[UIAlphaAnimation alloc] initWithTarget:self];
	[va setStartAlpha:1.0];
	[va setEndAlpha:0.0];
	
	UIAnimator *ua = [[UIAnimator alloc] init];
	[ua addAnimation:va withDuration:0.4 start:YES];
	
	[app unhideMenu];
}
#endif

- (void)dealloc
{
	[icon release];
	[logo release];
	[version release];
	int i;
	for(i=0;i<[labels count];i++)
		[[labels objectAtIndex:i] release];
	[labels release];
	[super dealloc];
}

@end