#import <CoreFoundation/CoreFoundation.h>
#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import <UIKit/UIApplication.h>
#import <UIKit/UIWindow.h>
#import <UIKit/UIView.h>
#ifndef ASPEN
#import "WebCore/WebFontCache.h"
#endif
#import <GraphicsServices/GraphicsServices.h>
#import "TrisBoardView.h"
#import "TrisSideView.h"
#import "TrisPiece.h"
#import "TrisAboutView.h"
#import "TrisGameOverView.h"
#import "TrisScoreView.h"

#ifdef ASPEN
// include for the sdk compiler and open toolchain headers
#ifndef UIKIT_UIFont_UIColor_H
#define UIKIT_UIFont_UIColor_H
typedef float CGFloat;
#import <UIKit/UIFont.h>
#import <UIKit/UIColor.h>
#endif //UIKIT_UIFont_UIColor_H

#ifndef UIKIT_UITouch_UIEvent_H
#define UIKIT_UITouch_UIEvent_H
typedef unsigned int NSUInteger;
#import <UIKit/UITouch.h>
#import <UIKit/UIEvent.h>
#endif //UIKIT_UITouch_UIEvent_H

//#define USE_LEGACY_EVENT

#endif //ASPEN

@interface TrisApp : UIApplication
{
	UIWindow *wnd;
	TrisBoardView *board;
	TrisSideView *sidebar;
	UIImageView *menu;
	TrisAboutView *aboutView;
	TrisGameOverView *overView;
	TrisScoreView *scoreView;
	UIPushButton *bResume;
	UIPushButton *bNewGame;
	UIPushButton *bHighScores;
	UIPushButton *bAbout;
#ifdef ASPEN
	UIPushButton *bQuit;
#endif

	int score;
	int rows;
	int level;
}

- (void)openMenu;
- (void)unhideMenu;
- (void)setNextPiece:(int)p;
- (void)cleared;
- (void)dropped:(int)dist;
- (void)saveScoreWithName:(NSString *)n;
- (void)showResumeButton:(BOOL)res;
- (void)lost;
- (UIAlphaAnimation *)buildFadeForTarget:(UIView *)targ fadeIn:(BOOL)i;
@end
