// main application class - handles the various subviews and relays stuff between them

#import "TrisApp.h"


@implementation TrisApp

BOOL aPaused;

BOOL gameInProgress;

- (void)applicationDidFinishLaunching:(id)notification
{

	wnd = [[[UIWindow alloc] initWithContentRect:[UIHardware fullScreenApplicationContentRect]] retain];
	[wnd orderFront: self];
	[wnd makeKey: self];
	board = [[[TrisBoardView alloc] initWithFrame:CGRectMake(0.f,0.f,230.f,460.f) app:self] retain];
	sidebar = [[[TrisSideView alloc] initWithFrame:CGRectMake(230.f,0.f,90.f,460.f) app:self] retain];
	UIView *mVu = [[UIView alloc] initWithFrame:CGRectMake(0.f,0.f,320.f,460.f)]; // main view
	[mVu addSubview:board];
	[mVu addSubview:sidebar];

	// preferences stuff
	NSUserDefaults *def = [NSUserDefaults standardUserDefaults];
	NSMutableArray *hSArr = [NSMutableArray arrayWithCapacity:10];
	int i;
	for(i=0;i<10;i++)
		[hSArr addObject:[NSArray arrayWithObjects:@"",[NSNumber numberWithInt:0],nil]];
	NSDictionary *d = [NSDictionary dictionaryWithObjectsAndKeys:@"",@"playerName",[NSArray arrayWithArray:hSArr],@"highScores",nil];
	[def registerDefaults:d];
	
	
	menu = [[[UIImageView alloc] initWithFrame:CGRectMake(14.0,73.0,202.0,325.0)] retain];
	[menu setImage:[UIImage applicationImageNamed:@"menubg.png"]];
	
#ifdef ASPEN
	UIFont *lFont = [UIFont fontWithName:@"Helvetica" size:22];
#else
	struct __GSFont *lFont = [NSClassFromString(@"WebFontCache") createFontWithFamily:@"Helvetica" traits:2 size:22];
#endif
	
	float whi[4] = {1.0,1.0,1.0,1.0};
	float gry[4] = {0.7,0.7,0.7,1.0};
	
	CGColorSpaceRef csp = CGColorSpaceCreateDeviceRGB();
	CGColorRef whc = CGColorCreate(csp,whi);
	CGColorRef grc = CGColorCreate(csp,gry);
	
	CGAffineTransform buttonOffset = CGAffineTransformMakeTranslation(0,-22.5);
	bResume = [[UIPushButton alloc] initWithFrame:CGRectMake(60.0,51.0,106.0,30.0)];
	[bResume setTitle:@"resume"];
	[bResume setTitleFont:lFont];
#ifdef ASPEN
	[bResume setTitleColor:[UIColor colorWithCGColor:whc] forState:0];
	[bResume setTitleColor:[UIColor colorWithCGColor:grc] forState:1];
#else
	[bResume setTitleColor:whc forState:0];
	[bResume setTitleColor:grc forState:1];
#endif
	[bResume addTarget:self action:@selector(resume:) forEvents:255];
	[menu addSubview:bResume];
	
	bNewGame = [[UIPushButton alloc] initWithFrame:CGRectMake(48.0,96.0,106.0,30.0)];
	[bNewGame setTitle:@"new game"];
	[bNewGame setTitleFont:lFont];
#ifdef ASPEN
	[bNewGame setTitleColor:[UIColor colorWithCGColor:whc] forState:0];
	[bNewGame setTitleColor:[UIColor colorWithCGColor:grc] forState:1];
#else
	[bNewGame setTitleColor:whc forState:0];
	[bNewGame setTitleColor:grc forState:1];
#endif
	[bNewGame addTarget:self action:@selector(newGame:) forEvents:255];
	[menu addSubview:bNewGame];
	
	bHighScores = [[UIPushButton alloc] initWithFrame:CGRectMake(40.0,141.0,122.0,30.0)];
	[bHighScores setTitle:@"high scores"];
	[bHighScores setTitleFont:lFont];
#ifdef ASPEN
	[bHighScores setTitleColor:[UIColor colorWithCGColor:whc] forState:0];
	[bHighScores setTitleColor:[UIColor colorWithCGColor:grc] forState:1];
#else
	[bHighScores setTitleColor:whc forState:0];
	[bHighScores setTitleColor:grc forState:1];
#endif
	[bHighScores addTarget:self action:@selector(highScores:) forEvents:255];
	[menu addSubview:bHighScores];
	
	bAbout = [[UIPushButton alloc] initWithFrame:CGRectMake(70.0,186.0,62.0,30.0)];
	[bAbout setTitle:@"about"];
	[bAbout setTitleFont:lFont];
#ifdef ASPEN
	[bAbout setTitleColor:[UIColor colorWithCGColor:whc] forState:0];
	[bAbout setTitleColor:[UIColor colorWithCGColor:grc] forState:1];
#else
	[bAbout setTitleColor:whc forState:0];
	[bAbout setTitleColor:grc forState:1];
#endif
	[bAbout addTarget:self action:@selector(about:) forEvents:255];
	[menu addSubview:bAbout];


#ifdef ASPEN
	bQuit = [[UIPushButton alloc] initWithFrame:CGRectMake(77.0,231.0,62.0,30.0)];
	[bQuit setTitle:@"Quit"];
	[bQuit setTitleFont:lFont];
	[bQuit setTitleColor:[UIColor colorWithCGColor:whc] forState:0];
	[bQuit setTitleColor:[UIColor colorWithCGColor:grc] forState:1];
	[bQuit addTarget:self action:@selector(quitGame:) forEvents:255];
	[menu addSubview:bQuit];
#endif
	
	[self showResumeButton:NO];
	
	aboutView = [[[TrisAboutView alloc] initWithApp:self] retain];
	overView = [[[TrisGameOverView alloc] initWithApp:self] retain];
	
	[overView setAlpha:0.0];
	
	scoreView = [[[TrisScoreView alloc] initWithApp:self] retain];
	[scoreView loadScores:[[NSUserDefaults standardUserDefaults] arrayForKey:@"highScores"]];
	
	[mVu addSubview:menu];
	[mVu addSubview:aboutView];
	[mVu addSubview:overView];
	[mVu addSubview:scoreView];
	
	[board becomeFirstResponder];
	[wnd setContentView:mVu];
	[sidebar setScore:0];
	[sidebar setLevel:1];
	
	aPaused = YES;
	gameInProgress = NO;
}

- (void)showResumeButton:(BOOL)res
{
	CGAffineTransform bT = CGAffineTransformMakeTranslation(0,-22.5);
	if(res)
	{
		bT = CGAffineTransformIdentity;
		[bResume setAlpha:1.0];
	}
	else
		[bResume setAlpha:0.0];

	[bNewGame setTransform:bT];
	[bHighScores setTransform:bT];
	[bAbout setTransform:bT];
#ifdef ASPEN
	[bQuit setTransform:bT];
#endif
}

- (void)cleared
{
	rows += 1;
	score += 100;
	[sidebar setScore:score];
	if(rows % 10 == 0)
	{
		float di = 0.4 - (rows / 10) * 0.02;
		if(di< 0.15 ) // don't let it get too fast
			di = 0.15;
		[board setDropInterval:di];
		[sidebar setLevel:((int)(rows/10) + 1)];
	}
}

- (void)dropped:(int)dist
{
	score += dist;
	[sidebar setScore:score];
}

- (void)lost
{
	[sidebar setPaused:YES];
	[self showResumeButton:NO];
	[board slowBlur];
	[overView setAlpha:0.0];
	[overView setTransform:CGAffineTransformIdentity];
	[[UIAnimator sharedAnimator] addAnimation:[self buildFadeForTarget:overView fadeIn:YES] withDuration:0.3 start:YES];
	[overView setScore:score];
	[overView showKeyboard:YES];
	aPaused = YES;
	gameInProgress = NO;
}

- (void)saveScoreWithName:(NSString *)n
{
	NSUserDefaults *def = [NSUserDefaults standardUserDefaults];
	[def setObject:n forKey:@"playerName"];
	NSMutableArray *scArr = [[def arrayForKey:@"highScores"] mutableCopy];

	int i;
	for(i=0;i<[scArr count];i++)
	{
		int oS = [(NSNumber *)[[scArr objectAtIndex:i] objectAtIndex:1] intValue];
		if(score > oS)
		{
			[scArr removeObjectAtIndex:[scArr count] - 1];
			[scArr insertObject:[NSArray arrayWithObjects:n,[NSNumber numberWithInt:score],nil] atIndex:i];
			break;
		}
	}
	[def setObject:[NSArray arrayWithArray:scArr] forKey:@"highScores"];
	[scoreView loadScores:scArr];
	[scArr release];
	
	[scoreView setAlpha:1.0];
	
	UITransformAnimation *goTa = [[UITransformAnimation alloc] initWithTarget:overView];
	UITransformAnimation *scTa = [[UITransformAnimation alloc] initWithTarget:scoreView];
	CGAffineTransform d = CGAffineTransformMakeTranslation(0,460);
	
	[goTa setStartTransform:CGAffineTransformIdentity];
	[goTa setEndTransform:d];
	[scTa setStartTransform:CGAffineTransformIdentity];
	[scTa setEndTransform:d];
	
	[[UIAnimator sharedAnimator] addAnimation:goTa withDuration:0.6 start:YES];
	[[UIAnimator sharedAnimator] addAnimation:scTa withDuration:0.6 start:YES];
	[goTa release];
	[scTa release];
}

- (void)resume:(UIPushButton *)b
{
	if(![b isPressed])
		return;
	aPaused = YES;
	[self openMenu];
}

- (void)newGame:(UIPushButton *)b
{
	if(![b isPressed])
		return;
	score = 0;
	level = 1;
	rows = 0;
	[board setDropInterval:0.5];
	[sidebar setScore:score];
	[sidebar setLevel:level];
	[board reset];
	aPaused = YES;
	gameInProgress = YES;
	[self openMenu];
}

- (void)quitGame:(UIPushButton *)b
{
	[self terminate];
}


- (void)highScores:(UIPushButton *)b
{
	if(![b isPressed])
		return;
	
	[scoreView setAlpha:0.0];
	[scoreView setTransform:CGAffineTransformMakeTranslation(0,460)];
	
	UIAnimator *ua = [UIAnimator sharedAnimator];
	[ua addAnimation:[self buildFadeForTarget:menu fadeIn:NO] withDuration:0.4 start:YES];
	[ua addAnimation:[self buildFadeForTarget:scoreView fadeIn:YES] withDuration:0.5 start:YES];
}

- (void)about:(UIPushButton *)b
{
	if(![b isPressed])
		return;
	
	UIAnimator *ua = [UIAnimator sharedAnimator];
	[ua addAnimation:[self buildFadeForTarget:menu fadeIn:NO] withDuration:0.4 start:YES];
	[ua addAnimation:[self buildFadeForTarget:aboutView fadeIn:YES] withDuration:0.5 start:YES];
}

- (void)unhideMenu
{
	[menu setTransform:CGAffineTransformIdentity];
	[[UIAnimator sharedAnimator] addAnimation:[self buildFadeForTarget:menu fadeIn:YES] withDuration:0.3 start:YES];
}

// not sure what this does but it should suspend the app (and thus pause the game) when the phone's locked
- (BOOL)isSuspendedUnderLock
{
	return YES;
}

// pause game when suspending
- (void)applicationWillSuspend
{
	if(aPaused == NO)
		[self openMenu];
}

// ...and resuming, just in case
- (void)applicationDidResume
{
	if(aPaused == NO)
		[self openMenu];
}

- (void)applicationWillTerminate
{
	// save the stuff
	[[NSUserDefaults standardUserDefaults] synchronize];
}

// don't let it terminate itself when suspending; that's just silly
- (void)applicationSuspend:(GSEvent *)evt
{
	// save the stuff
	[[NSUserDefaults standardUserDefaults] synchronize];
}

// as above
- (BOOL)suspendRemainInMemory
{
	return YES;
}

- (void)applicationDidResumeFromUnderLock
{
	[self applicationDidResume];
}

- (void)setNextPiece:(int)p
{
	[sidebar setNextPiece:p];
}

- (void)openMenu
{
	if(gameInProgress)
	{
		if(!aPaused)
		{
			[self showResumeButton:YES];
			
			[board pause];
			[sidebar setPaused:YES];
			
			// zoom/fade the menu in
			UITransformAnimation *scd = [[UITransformAnimation alloc] initWithTarget:menu];
			[scd setStartTransform:CGAffineTransformMakeScale(0.8,0.8)];
			[scd setEndTransform:CGAffineTransformIdentity];
			
			UIAnimator *ua = [[UIAnimator alloc] init];
			[ua addAnimation:scd withDuration:0.3 start:YES];
			[ua addAnimation:[self buildFadeForTarget:menu fadeIn:YES] withDuration:0.5 start:YES];
			[scd release];
		}
		else
		{
			[board unpause];
			[sidebar setPaused:NO];
			
			// ...and out again
			UITransformAnimation *scd = [[UITransformAnimation alloc] initWithTarget:menu];
			[scd setEndTransform:CGAffineTransformMakeScale(0.7,0.7)];
			[scd setStartTransform:CGAffineTransformIdentity];
			
			UIAnimator *ua = [[UIAnimator alloc] init];
			[ua addAnimation:scd withDuration:0.3 start:YES];
			[ua addAnimation:[self buildFadeForTarget:menu fadeIn:NO] withDuration:0.2 start:YES];
			[scd release];

		}
		aPaused = !aPaused;
	}
}

- (UIAlphaAnimation *)buildFadeForTarget:(UIView *)targ fadeIn:(BOOL)i
{
	UIAlphaAnimation *aa = [[[UIAlphaAnimation alloc] initWithTarget:targ] autorelease];
	if(i)
	{
		[aa setStartAlpha:0.0];
		[aa setEndAlpha:1.0];
	}
	else
	{
		[aa setStartAlpha:1.0];
		[aa setEndAlpha:0.0];
	}
	return aa;
}
	 
- (void)dealloc
{
	[board release];
	[sidebar release];
	[aboutView release];
	[overView release];
	[scoreView release];
	[menu release];
	[wnd release];
	[super dealloc];
}
@end
