#import <CoreFoundation/CoreFoundation.h>
#import <CoreGraphics/CoreGraphics.h>
#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import <UIKit/UIView.h>
#import <GraphicsServices/GraphicsServices.h>
#import <UIKit/UIView-Geometry.h>
#import "pieces.h"
#import "TrisPiece.h"
#import "TrisCell.h"

#ifdef ASPEN
// include for the sdk compiler and open toolchain headers
#ifndef UIKIT_UIFont_UIColor_H
#define UIKIT_UIFont_UIColor_H
typedef float CGFloat;
#import <UIKit/UIFont.h>
#import <UIKit/UIColor.h>
#endif //UIKIT_UIFont_UIColor_H

#ifndef UIKIT_UITouch_UIEvent_H
#define UIKIT_UITouch_UIEvent_H
typedef unsigned int NSUInteger;
#import <UIKit/UITouch.h>
#import <UIKit/UIEvent.h>
#endif //UIKIT_UITouch_UIEvent_H

#endif //ASPEN

@class TrisApp;

@interface TrisBoardView : UIView
{
	UIWindow *prnt;
	
	// images
	UIImage *bg;
	NSArray *pieces;
	TrisPiece *cPiece;
	TrisPiece *clearingPiece;
	NSMutableArray *cells;
	
	UIImageView *blurBgVu;
	
	TrisApp *app;
}

- (id)initWithFrame:(CGRect)frame app:(TrisApp *)a;

- (void)loadPieceCoords;
- (void)doDrop:(id)u;
- (BOOL)pieceLandedAtX:(int)cX Y:(int)cY;
- (void)placePiece;
- (void)rmClearing;

- (void)chooseNextPiece;
- (BOOL)value:(int)v notUsedIn:(int *)a;
- (BOOL)pieceCanMoveXDir:(int)d;
- (BOOL)pieceCanMoveYDir:(int)d;
- (void)tick;

- (void)rotatePieceRight:(BOOL)r;

- (void)pause;
- (void)slowBlur;
- (void)unpause;
- (void)resume:(id)uu;

- (void)setDropInterval:(float)i;

- (void)reset;

- (BOOL)checkRows;
- (void)resetPiece;

@end