#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import <UIKit/UIView.h>
#ifndef ASPEN
#import "WebCore/WebFontCache.h"
#endif
#import <GraphicsServices/GraphicsServices.h>
#import "TrisNameField.h"
#ifdef ASPEN
// include for the sdk compiler and open toolchain headers
#ifndef UIKIT_UIFont_UIColor_H
#define UIKIT_UIFont_UIColor_H
typedef float CGFloat;
#import <UIKit/UIFont.h>
#import <UIKit/UIColor.h>
#endif //UIKIT_UIFont_UIColor_H

#ifndef UIKIT_UITouch_UIEvent_H
#define UIKIT_UITouch_UIEvent_H
typedef unsigned int NSUInteger;
#import <UIKit/UITouch.h>
#import <UIKit/UIEvent.h>
#endif //UIKIT_UITouch_UIEvent_H

#endif //ASPEN


@class TrisApp;

@interface TrisGameOverView : UIView
{
	TrisApp *app;
	UIImageView *goT;
#ifdef ASPEN
	struct __GSFont *lFont;
#else
	UIFont *lFont;
#endif
	CGColorRef whc;
	CGColorRef tpc;
	NSArray *labels;
	UITextLabel *score;
	UITextLabel *enterName;
	UITextField *nameField;
	UIKeyboard *kb;
	BOOL kbVis;
}

- (id)initWithApp:(TrisApp *)a;
- (void)setScore:(int)scr;
- (void)showKeyboard:(BOOL)show;
- (UITransformAnimation *)buildMoveAnimForView:(UIView *)v move:(int)m startId:(BOOL)i;

@end
