#import "TrisGameOverView.h"

@interface TrisApp : UIApplication {}
	- (void)unhideMenu;
	- (void)saveScoreWithName:(NSString *)n;
@end

@implementation TrisGameOverView

- (id)initWithApp:(TrisApp *)a
{
	if(self = [super initWithFrame:CGRectMake(0.f,0.f,320.f,460.f)])
	{
		//[self setAlpha:0.0];
		app = a;
		goT = [[UIImageView alloc] initWithFrame:CGRectMake(47.5,62.f,135.f,94.f)];
		[goT setImage:[UIImage applicationImageNamed:@"gameover.png"]];
		[self addSubview:goT];
		
		CGColorSpaceRef csp = CGColorSpaceCreateDeviceRGB();
		float whf[4] = {1.0,1.0,1.0,1.0};
		float sdf[4] = {0.0,0.0,0.0,0.7};
		float tpf[4] = {0.0,0.0,0.0,0.0};
		
		float blf[4] = {0.0,0.0,0.0,0.4};
		[[self _layer] setBackgroundColor:CGColorCreate(csp,blf)];
		
		whc = CGColorCreate(csp,whf); // white text
		
		tpc = CGColorCreate(csp,tpf); // transparency (for background)
		
#ifdef ASPEN
		UIFont *vFont = [UIFont fontWithName:@"Helvetica" size:20];
#else
		struct __GSFont *vFont = [NSClassFromString(@"WebFontCache") createFontWithFamily:@"Helvetica" traits:2 size:20];
#endif
		CGColorRef sdc = CGColorCreate(csp,sdf); // shadow color
		
		score = [[[UITextLabel alloc] initWithFrame:CGRectMake(30,175,170,20)] retain];
		[score setFont:vFont];
#ifdef ASPEN
		[score setColor:[UIColor colorWithCGColor:whc]];
		[score setBackgroundColor:[UIColor colorWithCGColor:tpc]];
		[score setShadowColor:[UIColor colorWithCGColor:sdc]];
#else
		[score setColor:whc];
		[score setBackgroundColor:tpc];
		[score setShadowColor:sdc];

#endif
		[score setShadowOffset:CGSizeMake(0,2)];
		[score setCentersHorizontally:YES];
		[score setText:@"Score: 14159"];
		
		[self addSubview:score];
		
#ifdef ASPEN
		UIFont *eFont = [UIFont fontWithName:@"Helvetica" size:16];
#else
		struct __GSFont *eFont = [NSClassFromString(@"WebFontCache") createFontWithFamily:@"Helvetica" traits:2 size:16];
#endif
		
		enterName = [[[UITextLabel alloc] initWithFrame:CGRectMake(30,220,170,20)] retain];
		[enterName setFont:eFont];
#ifdef ASPEN
		[enterName setColor:[UIColor colorWithCGColor:whc]];
		[enterName setBackgroundColor:[UIColor colorWithCGColor:tpc]];
		[enterName setShadowColor:[UIColor colorWithCGColor:sdc]];
#else
		[enterName setColor:whc];
		[enterName setBackgroundColor:tpc];
		[enterName setShadowColor:sdc];
#endif
		[enterName setShadowOffset:CGSizeMake(0,2)];
		[enterName setCentersHorizontally:YES];
		[enterName setText:@"Enter your name:"];
		[self addSubview:enterName];
		
		nameField = [[[TrisNameField alloc] initWithFrame:CGRectMake(20,250,190,24)] retain];
		[nameField setFont:vFont];
		[nameField setTextCentersHorizontally:YES];
#ifdef ASPEN
		[nameField setTextColor:[UIColor colorWithCGColor:whc]];
#else
		[nameField setTextColor:whc];
#endif
		[nameField setDelegate:self];
#ifdef OK
		[nameField setEditingDelegate:self];
#endif
		[nameField setText:[[NSUserDefaults standardUserDefaults] stringForKey:@"playerName"]];
		[self addSubview:nameField];
		
#ifdef ASPEN
		[nameField setReturnKeyType:0];
		[nameField setKeyboardType:0];
		[nameField setAutocorrectionType:1];
#else
		kb = [[[UIKeyboard alloc] initWithDefaultSize] retain];
		[kb setFrame:CGRectMake(0,460,[kb frame].size.width,[kb frame].size.height)];
		//[kb setDelegate:self];
		[self addSubview:kb];
#endif
		
		kbVis = NO;
		
	}
	return self;
}

- (UITransformAnimation *)buildMoveAnimForView:(UIView *)v move:(int)m startId:(BOOL)i
{
	UITransformAnimation *a = [[[UITransformAnimation alloc] initWithTarget:v] autorelease];
	if(i)
	{
		[a setStartTransform:CGAffineTransformIdentity];
		[a setEndTransform:CGAffineTransformMakeTranslation(0,m)];
	}
	else
	{
		[a setStartTransform:CGAffineTransformMakeTranslation(0,m)];
		[a setEndTransform:CGAffineTransformIdentity];
	}
	return a;
}

- (BOOL)keyboardInput:(id)ki shouldInsertText:(id)t isMarkedText:(int)b
{
	if([t characterAtIndex:0] == 0xA)
	{
		//[self showKeyboard:NO];
		[app saveScoreWithName:[nameField text]];
		return NO;
	}
	else
		return YES;
}

- (void)showKeyboard:(BOOL)show
{
	kbVis = show;
	if(show)
	{
#ifndef ASPEN
		[kb activate];
#endif
		[nameField becomeFirstResponder];
	}
	else
	{
#ifndef ASPEN
		[kb deactivate];
#endif
		[nameField resignFirstResponder];
	}
	UIAnimator *ua = [UIAnimator sharedAnimator];
#ifndef ASPEN
	[ua addAnimation:[self buildMoveAnimForView:kb move:([kb frame].size.height * -1) startId:show] withDuration:0.4 start:YES];
#endif
	[ua addAnimation:[self buildMoveAnimForView:goT move:-35 startId:show] withDuration:0.3 start:YES];
	[ua addAnimation:[self buildMoveAnimForView:score move:-35 startId:show] withDuration:0.3 start:YES];
	[ua addAnimation:[self buildMoveAnimForView:enterName move:-45 startId:show] withDuration:0.3 start:YES];
	[ua addAnimation:[self buildMoveAnimForView:nameField move:-45 startId:show] withDuration:0.3 start:YES];
}

- (void)setScore:(int)scr
{
	[score setText:[NSString stringWithFormat:@"Score: %i",scr]];
}

#ifdef ASPEN
// this helps dismiss the keyboard then the "done" button is clicked
- (BOOL)textFieldShouldReturn:(UITextField *)textField
{
	[textField resignFirstResponder];
	[app saveScoreWithName:[nameField text]];
	return YES;
}
#endif

#if defined ASPEN && !defined USE_LEGACY_EVENT
- (void)touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event
{  	
	UIAlphaAnimation *va = [[UIAlphaAnimation alloc] initWithTarget:self];
	[va setStartAlpha:1.0];
	[va setEndAlpha:0.0];
	
	UIAnimator *ua = [[UIAnimator alloc] init];
	[ua addAnimation:va withDuration:0.4 start:YES];
	[app unhideMenu];
}

#else
- (void)mouseUp:(GSEvent *)evt
{
	/*if(kbVis)
		[self showKeyboard:NO];
	else
	{
		[self showKeyboard:YES];
	}*/
	//UITransformAnimation *ta = [[UITransformAnimation alloc] initWithTarget:self];
	//[ta setStartTransform:CGAffineTransformMakeTranslation(0,460)]; // from 460-pixels-below-where-it-started...
	//[ta setEndTransform:CGAffineTransformIdentity]; // to where-it-started.
	
	UIAlphaAnimation *va = [[UIAlphaAnimation alloc] initWithTarget:self];
	[va setStartAlpha:1.0];
	[va setEndAlpha:0.0];
	
	UIAnimator *ua = [[UIAnimator alloc] init];
	//[ua addAnimation:ta withDuration:0.4 start:YES];
	[ua addAnimation:va withDuration:0.4 start:YES];
	
	[app unhideMenu];
}

#endif

- (void)dealloc
{
	[goT release];
	[score release];
	[enterName release];
	[nameField release];
	[kb release];
	/*[icon release];
	[logo release];
	[version release];
	int i;
	for(i=0;i<[labels count];i++)
		[[labels objectAtIndex:i] release];
	[labels release];
	//[contact release];*/
	[super dealloc];
}

@end