#import <Foundation/Foundation.h>
#import "pieces.h"
#import <UIKit/UIKit.h>
#import <CoreGraphics/CoreGraphics.h>
#import <LayerKit/LKLayer.h>

@interface TrisPiece : NSObject
{	
	NSArray *iSrc;
	LKLayer *mainLyr;
	LKLayer *blocks[4];
	LKLayer *glows[4];
	int knd;
	int cRot;
	int tX;
	int tY;
	int minY;
}
+ (TrisPiece *)pieceWithKind:(int)ki imageSource:(NSArray *)sou;
- (id)initWithKind:(int)ki imageSource:(NSArray *)sou;
- (int)kind;
- (void)setKind:(int)ki;
- (void)rotL;
- (void)rotR;
- (void)movX:(int)dir;
- (void)movY:(int)dir;
- (int)rot;
- (void)setRot:(int)r;
- (void)setPos:(CGPoint)p;
- (void)setPosNoAnim:(CGPoint)p;
- (void)drop;
- (int)getYDragDistance;
- (int)xCell;
- (int)yCell;
- (LKLayer *)layer;
@end