#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import <UIKit/UIView.h>
#ifndef ASPEN
#import "WebCore/WebFontCache.h"
#endif
#import <GraphicsServices/GraphicsServices.h>

#ifdef ASPEN
// include for the sdk compiler and open toolchain headers
#ifndef UIKIT_UIFont_UIColor_H
#define UIKIT_UIFont_UIColor_H
typedef float CGFloat;
#import <UIKit/UIFont.h>
#import <UIKit/UIColor.h>
#endif //UIKIT_UIFont_UIColor_H

#ifndef UIKIT_UITouch_UIEvent_H
#define UIKIT_UITouch_UIEvent_H
typedef unsigned int NSUInteger;
#import <UIKit/UITouch.h>
#import <UIKit/UIEvent.h>
#endif //UIKIT_UITouch_UIEvent_H

#endif //ASPEN


@class TrisApp;

@interface TrisScoreView : UIView
{
	TrisApp *app;
#ifdef ASPEN
	UIFont *nFont;
	UIFont *bFont;
#else
	struct __GSFont *nFont;
	struct __GSFont *bFont;
#endif
	CGColorRef whc;
	CGColorRef tpc;
	UIImageView *hsV;
	NSArray *scoreNames;
	NSArray *scoreNums;
}

- (id)initWithApp:(TrisApp *)a;
#ifdef ASPEN
- (UITextLabel *)addLabelInFrame:(CGRect)frm text:(NSString *)txt centered:(BOOL)cent font:(UIFont *)font;
#else
- (UITextLabel *)addLabelInFrame:(CGRect)frm text:(NSString *)txt centered:(BOOL)cent font:(struct __GSFont *)font;
#endif
- (void)loadScores:(NSArray *)scs;

@end
