#import "TrisScoreView.h"

@interface TrisApp : UIApplication {}
	- (void)unhideMenu;
@end

@implementation TrisScoreView

- (id)initWithApp:(TrisApp *)a
{
	if(self = [super initWithFrame:CGRectMake(0,-460,320,461)])
	{
		app = a;
		
		hsV = [[UIImageView alloc] initWithFrame:CGRectMake(33,33,167,94)];
		[hsV setImage:[UIImage applicationImageNamed:@"highscores.png"]];
		[self addSubview:hsV];
		
		CGColorSpaceRef csp = CGColorSpaceCreateDeviceRGB();
		float whf[4] = {1.0,1.0,1.0,1.0};
		float sdf[4] = {0.0,0.0,0.0,0.7};
		float tpf[4] = {0.0,0.0,0.0,0.0};
		
		float blf[4] = {0.0,0.0,0.0,0.4};
		[[self _layer] setBackgroundColor:CGColorCreate(csp,blf)];
		
		whc = CGColorCreate(csp,whf); // white text
		
		tpc = CGColorCreate(csp,tpf); // transparency (for background)
		
#ifdef ASPEN
		nFont = [UIFont fontWithName:@"Helvetica" size:16];
		bFont = [UIFont fontWithName:@"Helvetica" size:16];
#else
		nFont = [NSClassFromString(@"WebFontCache") createFontWithFamily:@"Helvetica" traits:0 size:16];
		bFont = [NSClassFromString(@"WebFontCache") createFontWithFamily:@"Helvetica" traits:2 size:16];
#endif		
		NSMutableArray *nameArr = [NSMutableArray arrayWithCapacity:10];
		NSMutableArray *numArr = [NSMutableArray arrayWithCapacity:10];
		int i;
		for(i=0;i<10;i++)
		{
			[nameArr addObject:[self addLabelInFrame:CGRectMake(10,146+30*i,160,20) text:@"" centered:NO font:nFont]];
			[numArr addObject:[self addLabelInFrame:CGRectMake(170,146+30*i,60,20) text:@"" centered:YES font:bFont]];
		}
		scoreNames = [[NSArray arrayWithArray:nameArr] retain];
		scoreNums = [[NSArray arrayWithArray:numArr] retain];
	}
	return self;
}

- (void)loadScores:(NSArray *)scs
{
	int i;
	for(i=0;i<10;i++)
	{
		UITextLabel *name = [scoreNames objectAtIndex:i];
		UITextLabel *num = [scoreNums objectAtIndex:i];
		
		NSArray *cSarr = [scs objectAtIndex:i];
		
		NSNumber *cScore = [cSarr objectAtIndex:1];
		if([cScore intValue] > 0)
		{
			[name setText:[cSarr objectAtIndex:0]];
			[num setText:[cScore stringValue]];
		}
		else
		{
			[name setText:@""];
			[num setText:@""];
		}
	}
}

#ifdef ASPEN
- (UITextLabel *)addLabelInFrame:(CGRect)frm text:(NSString *)txt centered:(BOOL)cent font:(UIFont *)font
#else
- (UITextLabel *)addLabelInFrame:(CGRect)frm text:(NSString *)txt centered:(BOOL)cent font:(struct __GSFont *)font
#endif
{
	UITextLabel *t = [[[UITextLabel alloc] initWithFrame:frm] retain];
	[t setFont:font];
#ifdef ASPEN
	[t setColor:[UIColor colorWithCGColor:whc]];
	[t setBackgroundColor:[UIColor colorWithCGColor:tpc]];
#else
	[t setColor:whc];
	[t setBackgroundColor:tpc];
#endif
	[t setCentersHorizontally:cent];
	[t setText:txt];
	[self addSubview:t];
	return t;
}

#if defined ASPEN && !defined USE_LEGACY_EVENT
- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event
{  
	UIAlphaAnimation *va = [[UIAlphaAnimation alloc] initWithTarget:self];
	[va setStartAlpha:1.0];
	[va setEndAlpha:0.0];
	
	UIAnimator *ua = [[UIAnimator alloc] init];
	[ua addAnimation:va withDuration:0.4 start:YES];
	
	[app unhideMenu];
}
#else
- (void)mouseUp:(GSEvent *)evt
{
	
	UIAlphaAnimation *va = [[UIAlphaAnimation alloc] initWithTarget:self];
	[va setStartAlpha:1.0];
	[va setEndAlpha:0.0];
	
	UIAnimator *ua = [[UIAnimator alloc] init];
	[ua addAnimation:va withDuration:0.4 start:YES];
	
	[app unhideMenu];
}
#endif

- (void)dealloc
{
	int i;
	for(i=0;i<10;i++)
	{
		[[scoreNames objectAtIndex:i] release];
		[[scoreNums objectAtIndex:i] release];
	}
	[scoreNames release];
	[scoreNums release];
	[hsV release];
	[super dealloc];
}

@end