#import <CoreFoundation/CoreFoundation.h>
#import <CoreGraphics/CoreGraphics.h>
#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import <UIKit/UIView.h>
#ifndef ASPEN
#import "WebCore/WebFontCache.h"
#endif
#import <UIKit/NSString-UIStringDrawing.h>
#import <GraphicsServices/GraphicsServices.h>
#import <UIKit/UIView-Geometry.h>
#import "pieces.h"

#ifdef ASPEN
// include for the sdk compiler and open toolchain headers
#ifndef UIKIT_UIFont_UIColor_H
#define UIKIT_UIFont_UIColor_H
typedef float CGFloat;
#import <UIKit/UIFont.h>
#import <UIKit/UIColor.h>
#endif //UIKIT_UIFont_UIColor_H

#ifndef UIKIT_UITouch_UIEvent_H
#define UIKIT_UITouch_UIEvent_H
typedef unsigned int NSUInteger;
#import <UIKit/UITouch.h>
#import <UIKit/UIEvent.h>
#endif //UIKIT_UITouch_UIEvent_H

#endif //ASPEN

@class TrisApp;

@interface TrisSideView : UIView
{
	UIWindow *prnt;
	
	UIImage *bg;
	
	UIImage *menuImg;
	UIImage *menuSelImg;
	
	UITextLabel *lvlLbl;
	UITextLabel *rowLbl;
	UITextLabel *scoreLbl;
	
	UIImage *np;
	
	NSArray *nextPieceViews;
	
	TrisApp *app;
}

- (id)initWithFrame:(CGRect)frame app:(TrisApp *)a;

- (void)moveView:(int)i toX:(int)x Y:(int)y;
- (void)setPaused:(BOOL)p;
- (void)setNextPiece:(int)k;
- (void)setScore:(int)sc;
- (void)setLevel:(int)lv;
- (void)setRows:(int)rw;

@end